# Class ElementKindVisitor9<R,P>

java.lang.Object
javax.lang.model.util.AbstractElementVisitor6<R,P>
javax.lang.model.util.SimpleElementVisitor6<R,P>
javax.lang.model.util.ElementKindVisitor6<R,P>
javax.lang.model.util.ElementKindVisitor7<R,P>
javax.lang.model.util.ElementKindVisitor8<R,P>
javax.lang.model.util.ElementKindVisitor9<R,P>

Type Parameters:
  `R` - the return type of this visitor's methods. Use `Void` for visitors that do not need to return results.
  `P` - the type of the additional parameter to this visitor's methods. Use `Void` for visitors that do not need an additional parameter.

All Implemented Interfaces:
  `ElementVisitor<R,P>`

Direct Known Subclasses:
  `ElementKindVisitor14`

@SupportedSourceVersion(RELEASE_14) public class ElementKindVisitor9<R,P> extends ElementKindVisitor8<R,P>
A visitor of program elements based on their kind with default behavior appropriate for source versions `RELEASE_9` through `RELEASE_14`. For elements `Xyz` that may have more than one kind, the `visitXyz` methods in this class delegate to the `visitXyzAsKind` method corresponding to the first argument's kind. The `visitXyzAsKind` methods call `defaultAction`, passing their arguments to `defaultAction`'s corresponding parameters.

API Note:
  Methods in this class may be overridden subject to their general contract.
Since:
  9
See Also:
  - Compatibility note for subclasses
  - `ElementKindVisitor6`
  - `ElementKindVisitor7`
  - `ElementKindVisitor8`

- ## Field Summary

  ### Fields declared in class SimpleElementVisitor6

  `DEFAULT_VALUE`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `ElementKindVisitor9()`
  Constructor for concrete subclasses; uses `null` for the default value.
  `protected`
  `ElementKindVisitor9(R defaultValue)`
  Constructor for concrete subclasses; uses the argument for the default value.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `R`
  `visitModule(ModuleElement e, P p)`
  Visits a module element.

  ### Methods declared in class ElementKindVisitor7

  `visitVariableAsResourceVariable`

  ### Methods declared in class ElementKindVisitor6

  `visitExecutable, visitExecutableAsConstructor, visitExecutableAsInstanceInit, visitExecutableAsMethod, visitExecutableAsStaticInit, visitPackage, visitType, visitTypeAsAnnotationType, visitTypeAsClass, visitTypeAsEnum, visitTypeAsInterface, visitTypeAsRecord, visitTypeParameter, visitVariable, visitVariableAsBindingVariable, visitVariableAsEnumConstant, visitVariableAsExceptionParameter, visitVariableAsField, visitVariableAsLocalVariable, visitVariableAsParameter`

  ### Methods declared in class SimpleElementVisitor6

  `defaultAction`

  ### Methods declared in class AbstractElementVisitor6

  `visit, visit, visitRecordComponent, visitUnknown`

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### ElementKindVisitor9

    protected ElementKindVisitor9()
    Constructor for concrete subclasses; uses `null` for the default value.

  - ### ElementKindVisitor9

    protected ElementKindVisitor9(R defaultValue)
    Constructor for concrete subclasses; uses the argument for the default value.
    Parameters:
      `defaultValue` - the value to assign to `SimpleElementVisitor6.DEFAULT_VALUE`

- ## Method Details

  - ### visitModule

    public R visitModule(ModuleElement e, P p)
    Visits a module element.
    Specified by:
      `visitModule` in interface `ElementVisitor<R,P>`
    Overrides:
      `visitModule` in class `AbstractElementVisitor6<R,P>`
    Implementation Requirements:
      This implementation calls `defaultAction`.
    Parameters:
      `e` - the element to visit
      `p` - a visitor-specified parameter
    Returns:
      the result of `defaultAction`